//----------------------------------------------------------------------------
//Standard Template Library Examples
//      Adapted from console demos.
//
//Borland C++Builder
//Copyright (c) 1987, 2000 Borland International Inc. All Rights Reserved.
//----------------------------------------------------------------------------
/****************************************************************************
Thu 5/05/2005 2:12 pm. This is my hacked version of the STL demo that came
with Borland's C++Builder (kiddie-wheels "standard") version 5, around
"c:\Program Files\Borland\CBuilder5\Examples\StdLib\stdmain.bpr"; this file
should replace "c:\Program Files\Borland\CBuilder5\Examples\StdLib\std1.cpp"
-- actually there should be three files in the zip, std1.cpp, std1.dfm, and
std1.h, and all three must replace the original versions.

This little demo was obviously supposed to do the 120 or so STL demo programs
in that directory in one giant lump, but I would guess the programmer knew his
STL but couldn't figure-out Builder (it puzzled me, too, and I've been doing
Delphi since the flood); anyway they didn't finish it; note the pathetic
"Adapted from console demos" directly above; i.e., that was what was
*supposed* to happen. ...

But they can't stop *me* from hacking it, now that C++Builder is finding its
way to the ash heap of programming history. You probably have to do "make" in
the Examples\StdLib directory, which will make all of the little STL exes
after a while -- but only *if* you have "c:\Program
Files\Borland\CBuilder5\Bin" as the first entry on your path, which is how
Builder installs, but on our busy busy dev machines often other directories
creep up ahead of it especially after all these years, and of course if you
don't have exactly the right make, compiler, and linker, everything explodes.

Depending on your Windows operating system and the phase of the moon, you may
have to discipline the "DOS box" which will pop-up whenever you select an EXE
file from the dropdown list; I "system()" the thing below ("execit") and write
the output to a file, which I then load into the memo, but in the process
there's a DOS box -- which frequently works.... Note also I tried to exclude
the few demos that required input, but I probably missed some, at which point
everything'll hang-up, although clicking on the DOS box and typing something
(followed by Enter) might subdue it....

Anyway, this version of std1.cpp provides an amusing demonstration of STL, as
it was in 1999 (think of the Prince song).

j.g. owen * * * * * * * * * * * * * * * * * * *
web:   http://owenlabs.home.att.net/
email: owen_bda4@yahoo.com
* * * * * * * * * * * * * * * * * * * * * * * *

****************************************************************************/

//---------------------------------------------------------------------------
#include <vcl.h>
#pragma hdrstop

#define DEBUG (0)

#include "std1.h"
#include "sbrs.hpp"
//---------------------------------------------------------------------------
#pragma resource "*.dfm"
int ct;
TForm1 *Form1;
extern int accum_ex();
//---------------------------------------------------------------------------
__fastcall TForm1::TForm1(TComponent* Owner)
        : TForm(Owner)
{
}
//---------------------------------------------------------------------------
void build_all()
{
     accum_ex();
}


/****************************************************************************
****************************************************************************/

#include <io.h>
#include <dir.h>

/* used to be ((x)&15) */
#define AD1(x) (toupper(x)-'@')    /* alpha-drive, 1-based. */

/* like chdir, except works (does drive too); returns -1 if badness. */
int setpath(char *path) {
  int drive;
  if (path[0] && (path[1]==':') ) { /* do drive spec please! */
    drive= (AD1(path[0])) -1;   /* a|A.. ==> 0.. */
    setdisk(drive);
    if (getdisk() != drive) return -1;
    if (!path[2]) return 0;      /* JUST a drive spec. */
  }
  return chdir(path);
}

/* return nz if file name exists. evades append. */
int exist(char *name) {
  return !access(name,0);
}


void excuse(AnsiString s = "") {
  Form1->Label_Excuse->Caption = s;
}

void memoweird(void) {
    excuse("(original example)");
    Form1->Memo1->Clear();
    for (int j = 0; j < 200; j++)
    Form1->Memo1->Lines->Add("");
//        if (Form1->Memo1->Lines->Strings[j] != "")
//                Form1->Memo1->Lines->Strings[j] = " "; // make space in Memo
}

bool exeit(AnsiString exename) {
  static
  const AnsiString tname = "Std~";

  excuse();


  AnsiString s = exename + " | dezero > "+tname;
  system(s.c_str());

  if (exist(tname.c_str())) {
    Form1->Memo1->Lines->LoadFromFile(tname);
//    Form1->Memo1->Lines->Insert(0,
//    Format(":::::::: output of %s:",ARRAYOFCONST( (exename) ) )
//    );
    excuse(
    Format("output of %s",ARRAYOFCONST( (exename) ) )
    )
    ;

#if 0
//so I fix this with the dezero thing above (the generate function in alg1).
//Sigh...
    if (stricmp("alg1.exe",exename.c_str())==0) {
      excuse(
      Format("output of alg1.exe"
      " (which sadly emits some \\0s, so it's truncated)",
      ARRAYOFCONST( (0) ) ) );
    }
#endif

    Form1->Button_Src->Visible = true;
    return true;
  }

  Form1->Memo1->Text = "Couldn't find " + tname;
  return false;
}

//---------------------------------------------------------------------------
void __fastcall TForm1::ComboBox1Change(TObject *Sender)
{
    Button_Src->Visible = false;
    Button_Src->Caption = "Source?";
//    for (int j = 0; j < 200; j++)
//        if (Memo1->Lines->Strings[j] != "")
//                Memo1->Lines->Strings[j] = " "; // make space in Memo
    ct = 0;
        switch (ComboBox1->ItemIndex)
    {
       case 0:
        memoweird();
        build_all();
        break;
       case 1:
        memoweird();
        accum_ex();
        break;
       default:
        if (!exeit(ComboBox1->Items->Strings[ComboBox1->ItemIndex]))
        ShowMessage ("Sorry, not implemented yet");
        break;
    }
}
//---------------------------------------------------------------------------

#if defined(__FLAT__)
char *findfinish(struct ffblk *ffblk) {
  findclose(ffblk);
  return NULL;
}
#define STARNAME "*"
#else
#define findfinish(x) NULL
#define STARNAME "*.*"
#endif


char *getwildthisdir(char *name) {
  static struct ffblk ffblk;
  if (name) {
    if (findfirst(name,&ffblk,0))
    return findfinish(&ffblk);
  }
  else {
    if (findnext(&ffblk))
    return findfinish(&ffblk);
  }
  return ffblk.ff_name;
}

/****************************************************************************
****************************************************************************/
AnsiString original_directory, program_directory;

void  __fastcall TForm1::figger_exes_etc(void) {
  char *aname = getwildthisdir("*.exe");
  TStringList *alist = new TStringList;

  while(aname) {
    if (
    (stricmp(aname,"stdmain.exe")) //skip THIS program pleze.
    && (stricmp(aname,"calc.exe")) //wants input; there are probably others
                                   //I missed.
    && (stricmp(aname,"concord.exe"))  //I grepped for "cin" and got these.
    && (stricmp(aname,"io_iter.exe"))  //but I still probably missed some.
    && (stricmp(aname,"spell.exe"))
    && (stricmp(aname,"stocks.exe"))
    && (stricmp(aname,"string.exe"))
    )
//    ComboBox1->Items->Add(aname);
    alist->Add(aname);
    aname = getwildthisdir(NULL);
  }

  alist->Sorted = true; //yes they're much easier to find.
  //but see I *don't* want to sort those original two entries.

  ComboBox1->Items->Clear();
//  ComboBox1->ItemIndex = 0;
  ComboBox1->Items->AddStrings(alist);
  ComboBox1->ItemIndex = 0;

  delete alist;

}

void  __fastcall TForm1::figger_dir(void) {
  if (CheckBox_directory->Checked)
  setpath(program_directory.c_str());
  else
  setpath(original_directory.c_str());
#if 0 //DEBUG
  CheckBox_directory->Caption = getcwd(NULL,MAXPATH);
#endif
}


void __fastcall TForm1::FormCreate(TObject *Sender)
{
#if DEBUG
  setpath("c:\\elsecoms");
#endif
  original_directory = getcwd(NULL, MAXPATH);
  program_directory = ExtractFilePath(__argv[0]);
  figger_dir();
  figger_exes_etc();

}

//---------------------------------------------------------------------------

void __fastcall TForm1::CheckBox_directoryClick(TObject *Sender)
{
  static int here;
  if (here)
  return;

  here = 1;
  if
  (
  (!CheckBox_directory->Checked) &&
  (
  !usuref("You sure \"%s\" contains appropriate files? Go ahead?",
  ARRAYOFCONST( (original_directory.c_str()) ))
  )
  ) {
    CheckBox_directory->Checked = true;
  }
  else {

    figger_dir();
    figger_exes_etc();

  }

  here = 0;
}


/****************************************************************************
****************************************************************************/


//---------------------------------------------------------------------------

void __fastcall TForm1::Button_SrcClick(TObject *Sender)
{
  AnsiString aname = ComboBox1->Items->Strings[ComboBox1->ItemIndex];

  if (Button_Src->Caption.c_str()[0]=='S') {
    //show source.
    excuse();

    if (stricmp(ExtractFileExt(aname).c_str(),".exe")) {
      Application->MessageBox("Select an exe in the list box!",
      "oops",MB_OK);
      return;
    }

    aname = ChangeFileExt(aname,".cpp");

    if (exist(aname.c_str())) {
      Form1->Memo1->Lines->LoadFromFile(aname);
      excuse(
      Format("source %s",ARRAYOFCONST( (aname) ) )
      )
      ;


      Button_Src->Caption = "Execute?";
    }
    else {
      AnsiString x = aname + " doesn't exist";
      Application->MessageBox(x.c_str(),"sorry",MB_OK);
    }
  }
  else {
    if (exeit(aname))
    Button_Src->Caption = "Source?";

  }

}
//---------------------------------------------------------------------------

void __fastcall TForm1::Font_buttonClick(TObject *Sender)
{
  FontDialog->Font = Memo1->Font;
  if (FontDialog->Execute()) {
    Memo1->Font = FontDialog->Font;
  }
}
//---------------------------------------------------------------------------

